<?php

/** @var array $stations */
$stations;

$searchedGasStation = null;
$searchedCode = $_GET['search_code'] ?? null;

if ($searchedCode !== null) {
    foreach ($stations as $gasStation) {
        if ($gasStation['code'] == $searchedCode) {
            $searchedGasStation = $gasStation;
            break;
        }
    }
};
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $editedIndex = $_POST['edited_index'] ?? -1;
    $editedGasStation = $stations[$editedIndex] ?? null;


    if (empty($_POST['firm'])) {
        $errors['firm'] = 'Поле "Фірма" не може бути порожнім';
    }


    if (!is_numeric($_POST['litre']) || $_POST['litre'] < 0) {
        $errors['litre'] = 'Поле "Літр" повинно бути невід\'ємним числом';
    }

    if (empty($errors)) {
        if ($editedIndex !== -1) {
            $stations[$editedIndex] = [
                'code' => $_POST['code'],
                'adress' => $_POST['adress'],
                'firm' => $_POST['firm'],
                'fuel' => $_POST[
                'fuel'
                ],
                'price' => $_POST['price'],
                'litre' => $_POST['litre'],
            ];
        }
    }
}
$errors = [];

?>

<table border="1">
    <thead>
    <th>Code</th>
    <th>Adress</th>
    <th>Firm</th>
    <th>Litre</th>
    <th>Fuel</th>
    <th>Price</th>
    <th>Actions</th>
    </thead>
    <?php foreach ($stations as $key => $gasStation): ?>
        <tr>
            <td><?= $gasStation['code']; ?></td>
            <td><?= $gasStation['adress']; ?></td>
            <td><?= $gasStation['firm']; ?></td>
            <td><?= $gasStation['litre']; ?></td>
            <td><?=  $gasStation['fuel']; ?></td>
            <td><?=  $gasStation['price']; ?></td>
            <td>

                <form method="POST" action="">
                    <input type="hidden" name="delete_index" value="<?= $key; ?>">
                    <button type="submit">Видалити</button>
                </form>
            </td>
        </tr>
    <?php endforeach; ?>
</table>

<form method="GET" action="">
    <label for="search_code">Пошук за кодом:</label>
    <input type="text" id="search_code" name="search_code">
    <button type="submit">Пошук</button>
</form>
<?php if ($searchedGasStation !== null): ?>
    <h2>Результат пошуку:</h2>
    <table border="1">
        <thead>
        <th>Code</th>
        <th>Adress</th>
        <th>Firm</th>
        <th>Litre</th>
        <th>Fuel</th>
        <th>Price</th>
        <th>Actions</th>
        </thead>
        <tr>
            <td><?= $searchedGasStation['code']; ?></td>
            <td><?= $searchedGasStation['adress']; ?></td>
            <td><?= $searchedGasStation['firm']; ?></td>
            <td><?= $searchedGasStation['litre']; ?></td>
            <td><?=  $searchedGasStation['fuel']; ?></td>
            <td><?=  $searchedGasStation['price']; ?></td>
            <td>
                <form method="POST" action="">
                    <input type="hidden" name="edited_index" value="<?= $searchedGasStation['code']; ?>">
                    <button type="submit">Редагувати</button>
                </form>
            </td>
        </tr>
    </table>
<?php endif; ?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Редагування об'єкта</title>
</head>
<body>
<h1>Редагування об'єкта</h1>
<form method="post" action="">
    <input type="hidden" name="edited_index" value="<?= $editedIndex; ?>">

    <label for="code">Код:</label>
    <input type="text" id="code" name="code" value="<?= htmlspecialchars($editedGasStation['code'] ?? ''); ?>"><br>

    <label for="adress">Адреса:</label>
    <input type="text" id="adress" name="adress" value="<?= htmlspecialchars($editedGasStation['adress'] ?? ''); ?>"><br>

    <label for="firm">Фірма:</label>
    <input type="text" id="firm" name="firm" value="<?= htmlspecialchars($editedGasStation['firm'] ?? ''); ?>">
    <?php if (!empty($errors['firm'])): ?>
        <p class="error"><?= $errors['firm']; ?></p>
    <?php endif; ?>
    <br>

    <label for="fuel">Пальне :</label>
    <input type="text" id="fuel" name="fuel" value="<?= htmlspecialchars($editedGasStation['fuel'] ?? ''); ?>"><br>


    <label for="price">Ціна :</label>
    <input type="text" id="price" name="price" value="<?= htmlspecialchars($editedGasStation['price'] ?? ''); ?>"><br>


    <label for="litre">Літр:</label>
    <input type="text" id="litre" name="litre" value="<?= htmlspecialchars($editedGasStation['litre'] ?? ''); ?>">
    <?php if (!empty($errors['litre'])): ?>
        <p class="error"><?= $errors['litre']; ?></p>
    <?php endif; ?>
    <br>

    <button type="submit" name="submit">Зберегти зміни</button>
</form>
</body>
</html>